#PBFORMS CREATED V2.01
#COMPILE EXE
#DIM ALL

#INCLUDE ONCE "WIN32API.INC"
#INCLUDE ONCE "COMMCTRL.INC"
#INCLUDE ONCE "PBForms.INC"
%IDD_DIALOG1  =  101
%TXT_TEXTBOX1 = 1001
%CMD_BUTTON1  = 1002
%TXT_TEXTBOX2 = 1003

DECLARE FUNCTION fasm_GetVersion   LIB "FASM.DLL" ALIAS "fasm_GetVersion" () AS LONG
DECLARE FUNCTION fa     LIB "FASM.DLL" ALIAS "fasm_Assemble" _
                                                  (BYVAL pSource AS DWORD, _
                                                   BYVAL pFasmMemory AS DWORD, _
                                                   BYVAL cMemorySize AS DWORD, _
                                                   BYVAL passLImit AS DWORD, _
                                                   BYVAL hDispPipe AS LONG ) AS LONG

DECLARE FUNCTION fasm_AssembleFile LIB "FASM.DLL" () AS LONG

DECLARE CALLBACK FUNCTION ShowDIALOG1Proc()
DECLARE FUNCTION ShowDIALOG1(BYVAL hParent AS DWORD) AS LONG

$fasm_source_demo = _
    "org 100h" & $CRLF & _
    "mov ah,09h" & $CRLF & _
    "mov dx,text" & $CRLF & _
    "mov ah,09h" & $CRLF & _
    "int 21h" & $CRLF & _
    "int 20h" & $CRLF & _
    "text db ""Hello!"", 24h" & $CRLF

UNION Ubuff
    out_len AS DWORD
    errcode AS LONG
END UNION

UNION Ufile
    out_data AS DWORD
    errline  AS LONG
END UNION

UNION UOffs
    file_offset AS DWORD
    macro_calling_line AS DWORD
END UNION


TYPE TLINE_HEADER
  file_path   AS DWORD
  line_number AS DWORD
  offs AS UOffs
  macro_line  AS DWORD
END TYPE


TYPE TFASM_STATE
    cond AS DWORD
    buff AS UBuff
    file AS UFile
END TYPE

FUNCTION fasm (BYVAL inSrc$, BYVAL OutBinFile$) AS STRING
    LOCAL FASM_State  AS TFASM_STATE
    LOCAL LINE_HEADER AS TLINE_HEADER

    LOCAL a1 AS STRING * 10000, pa1 AS STRING PTR, _
          b1 AS STRING * 10000, pb1 AS BYTE PTR, _
          binrBuf, binrHex AS STRING, _
          r,i AS LONG

    a1 = insrc$
    pa1 = VARPTR(a1)
    b1 = STRING$(10000, 0)
    pb1 = VARPTR(b1)

    CALL fa (pa1, pb1,10000,100,0) TO r

    TYPE SET FASM_STATE = LEFT$(b1, SIZEOF(TFASM_STATE))

    IF r THEN
       TYPE SET LINE_HEADER = PEEK$(FASM_STATE.file.errline,SIZEOF(TLINE_HEADER))

       FUNCTION = "ERROR!" & $CRLF & _
                  "Condition: " & STR$(FASM_STATE.cond) & $CRLF & _
                  "Code: " & STR$(FASM_STATE.buff.errcode) & " Line: " & STR$(LINE_HEADER.line_number)
       EXIT FUNCTION
    END IF

    binrBuf = PEEK$(FASM_STATE.file.out_data, FASM_STATE.buff.out_len)

    IF LEN(OutBinFile$) THEN
       DIM F AS LONG: F=FREEFILE: OPEN OutBinFile$ FOR OUTPUT AS #f
       PRINT #f,binrBuf;
       CLOSE #f
    END IF
    FOR i = 1 TO FASM_STATE.buff.out_len
        IF i MOD 10 =0 THEN
           binrHex &= $CRLF
        ELSE
           binrHex &= HEX$( ASC(binrBuf,i), 2) & $SPC
        END IF
    NEXT i
    FUNCTION = binrHex
END FUNCTION

FUNCTION PBMAIN()
    PBFormsInitComCtls (%ICC_WIN95_CLASSES OR %ICC_DATE_CLASSES OR %ICC_INTERNET_CLASSES)
    ShowDIALOG1 %HWND_DESKTOP
END FUNCTION

CALLBACK FUNCTION ShowDIALOG1Proc()
    LOCAL sBuffer     AS STRING * 10000, _
          fasm_Memory AS STRING * 10000, tSrc, oSrc AS STRING

   LOCAL r AS LONG

    SELECT CASE AS LONG CB.MSG
        CASE %WM_INITDIALOG

        CASE %WM_NCACTIVATE
            STATIC hWndSaveFocus AS DWORD
            IF ISFALSE CB.WPARAM THEN
                hWndSaveFocus = GetFocus()
            ELSEIF hWndSaveFocus THEN
                SetFocus(hWndSaveFocus)
                hWndSaveFocus = 0
            END IF

        CASE %WM_COMMAND
            SELECT CASE AS LONG CB.CTL
                CASE %IDCANCEL
                    DIALOG END CB.HNDL,0
                CASE %CMD_BUTTON1
                    IF CB.CTLMSG = %BN_CLICKED OR CB.CTLMSG = 1 THEN
                       CONTROL GET TEXT CB.HNDL, 1001 TO tSrc
                       tSrc &= $NUL
                       fasm(tsrc, "MyFile.bin") TO oSrc
                       CONTROL SET TEXT CB.HNDL, 1003, oSrc
                    END IF
            END SELECT
    END SELECT
END FUNCTION

FUNCTION ShowDIALOG1(BYVAL hParent AS DWORD) AS LONG
    LOCAL lRslt  AS LONG
    LOCAL hDlg   AS DWORD
    LOCAL hFont1 AS DWORD
    LOCAL hFont2 AS DWORD
    '
    ' Get Fasm Version
    '
    DIALOG NEW hParent, "Flat Assemler " , 288, 226, 179, 228, TO hDlg

    CONTROL ADD TEXTBOX, hDlg, %TXT_TEXTBOX1, "", 3, 3, 171, 102, %WS_CHILD _
        OR %WS_VISIBLE OR %WS_BORDER OR %WS_TABSTOP OR %WS_HSCROLL OR _
        %WS_VSCROLL OR %ES_LEFT OR %ES_MULTILINE OR %ES_AUTOHSCROLL OR _
        %ES_AUTOVSCROLL OR %ES_WANTRETURN, %WS_EX_CLIENTEDGE OR %WS_EX_LEFT _
        OR %WS_EX_LTRREADING OR %WS_EX_RIGHTSCROLLBAR
    CONTROL ADD BUTTON,  hDlg, %CMD_BUTTON1, "Assemble ...", 3, 105, 171, 15
    CONTROL ADD TEXTBOX, hDlg, %TXT_TEXTBOX2, "", 3, 120, 171, 105, %WS_CHILD _
        OR %WS_VISIBLE OR %WS_BORDER OR %WS_TABSTOP OR %WS_HSCROLL OR _
        %WS_VSCROLL OR %ES_LEFT OR %ES_MULTILINE OR %ES_AUTOHSCROLL OR _
        %ES_AUTOVSCROLL OR %ES_WANTRETURN, %WS_EX_CLIENTEDGE OR %WS_EX_LEFT _
        OR %WS_EX_LTRREADING OR %WS_EX_RIGHTSCROLLBAR
    FONT NEW "Helvetica", 8, 0, %RUSSIAN_CHARSET TO hFont1
    FONT NEW "Fixedsys", 8, 0, %RUSSIAN_CHARSET TO hFont2
    CONTROL SET FONT hDlg, %TXT_TEXTBOX1, hFont1
    CONTROL SET FONT hDlg, %TXT_TEXTBOX2, hFont2
    CONTROL SET TEXT hDlg, 1001, $fasm_source_demo
    DIALOG SHOW MODAL hDlg, CALL ShowDIALOG1Proc TO lRslt
    FONT END hFont1
    FONT END hFont2
    FUNCTION = lRslt
END FUNCTION
